unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  jana2remote, commdefs, StdCtrls, Buttons, Spin, ExtCtrls, Menus, ImgList,
  registry, ComCtrls,Clipbrd,shellapi, CoolTrayIcon;

const
  icon_InternalError  = 7;
  icon_ExternalError  = 6;
  icon_OfflineLocked  = 8;
  icon_Offline        = 3;
  icon_Dialing        = 1;
  icon_Online         = 0;
  icon_OnlineData     = 2;
  icon_OnlineMail     = 5;
  icon_OnlineMailData = 4;

  text_InternalError  = 'Interner Fehler';
  text_Dialing        = 'Anwahl';
  text_OnlineMail     = 'Verbunden fr Mail';
  text_Online         = 'Verbunden';
  text_Offline        = 'Nicht verbunden';
  text_Error          = 'Verbindungsaufbau gescheitert';
  text_Locked         = 'DF gesperrt';
  text_Unlocked       = 'DF nicht gesperrt';

  OfflineIP           = '0.0.0.0';

type
  TJana2Remote2Config = class(TForm)
    CoolTrayIcon1: TCoolTrayIcon;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    Einstellungen1: TMenuItem;
    N1: TMenuItem;
    LogOut1: TMenuItem;
    Mailsabholen1: TMenuItem;
    Df1: TMenuItem;
    N2: TMenuItem;
    Ende1: TMenuItem;
    ImageList2: TImageList;
    Timer1: TTimer;
    Aktiviert: TCheckBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ProxyPort: TSpinEdit;
    Abfrageinterval: TSpinEdit;
    ProxyHost: TEdit;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Internetverbindungen: TEdit;
    Status: TEdit;
    DFUEGesperrt: TEdit;
    Zeitbisauflegen: TEdit;
    DFUEIP: TEdit;
    Onlinezeit: TEdit;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    Jana2Remote1: TJana2Remote;
    BitBtn4: TBitBtn;
    StatusBar1: TStatusBar;
    BitBtn5: TBitBtn;
    N3: TMenuItem;
    IPindieZwischenablagekopieren1: TMenuItem;
    BalloonInfo: TCheckBox;
    Jana2Einstellungen1: TMenuItem;
    N4: TMenuItem;
    Jana2beenden1: TMenuItem;
    Label10: TLabel;
    httpBenutzername: TEdit;
    Label11: TLabel;
    httpPasswort: TEdit;
    Jana2neustarten1: TMenuItem;
    procedure Ende1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Einstellungen1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure LogOut1Click(Sender: TObject);
    procedure Mailsabholen1Click(Sender: TObject);
    procedure Df1Click(Sender: TObject);
    procedure Jana2Remote1Error(Sender: TObject; Text: String);
    procedure BitBtn5Click(Sender: TObject);
    procedure IPindieZwischenablagekopieren1Click(Sender: TObject);
    procedure Jana2Einstellungen1Click(Sender: TObject);
    procedure Jana2beenden1Click(Sender: TObject);
    procedure Jana2neustarten1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure WMEndSession(var Msg:TWMEndSession); message WM_ENDSESSION;
  public
    { Public-Deklarationen }
    HighestTimeToDisconnect : integer;
    DoBalloonInfo:boolean;
  end;

var
  Jana2Remote2Config: TJana2Remote2Config;

implementation
 uses Defs;
{$R *.DFM}

procedure TJana2Remote2Config.Ende1Click(Sender: TObject);
begin
  Application.Mainform.Close;
end;

procedure TJana2Remote2Config.BitBtn4Click(Sender: TObject);
begin
  ShowMessage(Author+#13#10+'-=-=-=-'+#13#10#13#10+Links+#13#10+'-=-=-=-'+#13#10#13#10+License+#13#10+Disclaimer);
end;

procedure TJana2Remote2Config.Einstellungen1Click(Sender: TObject);
begin
  Jana2Remote2Config.Show;
end;

procedure TJana2Remote2Config.BitBtn1Click(Sender: TObject);
begin
  BitBtn5Click(Sender);
  Hide;
end;

procedure TJana2Remote2Config.BitBtn2Click(Sender: TObject);
begin
  Hide;
end;

procedure TJana2Remote2Config.FormShow(Sender: TObject);
begin
  // Komponenten-Informationen in die Edit-Felder einlesen
  Aktiviert.Checked := Timer1.Enabled;
  Abfrageinterval.Value := Timer1.Interval;
  ProxyPort.Value := Jana2Remote1.Port;
  ProxyHost.Text := Jana2Remote1.Host;
  BalloonInfo.Checked := DoBalloonInfo;
end;

procedure TJana2Remote2Config.FormCreate(Sender: TObject);
var Reg:TRegInifile;
begin
  // Registry-Informationen in die Komponenten einlesen
  Reg := TRegIniFile.Create('Software\Ulf Schaper');
  Jana2Remote1.Port := Reg.ReadInteger('Jana 2 Remote 2','Proxy Port',4295);
  Jana2Remote1.Host := Reg.ReadString('Jana 2 Remote 2','Proxy Host','127.0.0.1');
  Timer1.Interval := Reg.ReadInteger('Jana 2 Remote 2','Abfrageinterval',1000);
  Timer1.Enabled := Reg.ReadBool('Jana 2 Remote 2','Aktiviert',false);
  DoBalloonInfo := Reg.ReadBool('Jana 2 Remote 2','Ballooninfo',true);
  HTTPBenutzername.Text := Reg.ReadString('Jana 2 Remote 2','HTTP User','');
  HTTPPasswort.Text := Reg.ReadString('Jana 2 Remote 2','HTTP Passwort','');
  Reg.Free;
  ImageList1.GetIcon(icon_InternalError,CoolTrayIcon1.Icon);
  CoolTrayIcon1.Refresh;
end;

procedure TJana2Remote2Config.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  // komplett von Domis geklaut
  if Application.Messagebox('Keine berwachung des Proxy-Servers nach Beendigung des Programmes!','Beenden',mb_OKCancel)=IDOK then
    begin
      Action := caFree;
    end
  else
    Action := caNone;
end;

procedure TJana2Remote2Config.WMEndSession(var Msg:TWMEndSession);
begin
  // Programm wird beendet --> Abfragen abstellen
  Timer1.Enabled := false;
end;

function TimeStrFromSec(Sec : Integer) : String;
// von domis geklaut und bearbeitet
var h,m,s : Integer;
begin
  if Sec > 0 then
   begin
    h := Sec div 3600;
    m := (Sec div 60) mod 60;
    s := Sec mod 60;
    TimeStrFromSec := Format('%d:%2.2d:%2.2d',[h,m,s]);
   end else begin
    h := -Sec div 3600;
    m := (-Sec div 60) mod 60;
    s := -Sec mod 60;
    TimeStrFromSec := '-'+Format('%d:%2.2d:%2.2d',[h,m,s]);
   end;
end;

procedure TJana2Remote2Config.Timer1Timer(Sender: TObject);
const StatusAuswahl  : array [0..4] of string = (text_Offline,text_Online,text_Error,text_Dialing,text_locked);
      LockAuswahl    : array [0..1] of String = (text_UnLocked,text_Locked);
var InetConns,ConnState,LockState,TimeToDisconnect,Onlinetime:Integer;
    DUNIP,Statustext,Sperrtext:string;
var IconNr:byte;
begin
// Infos Updaten
 StatusBar1.SimpleText := DateTimeToStr(Now)+ ' Beginne Proxy-Abfrage';

// Zuerst die TCP-Infos
 InetConns := Jana2Remote1.GetNumberOfConnections(not Jana2Remote1.TCPBeschaeftigt);
 TimeToDisconnect := Jana2Remote1.GetSecondsToDisconnect(false);
 Onlinetime := Jana2Remote1.GetOnlineSeconds(false);
 DUNIP := Jana2Remote1.GetDialUpIP(false);

// Dann folgt UDP
 if not Timer1.Enabled then Exit;
 if Jana2Remote1.UDPBeschaeftigt then Exit;
 ConnState := Jana2Remote1.GetConnectionState;

 if not Timer1.Enabled then Exit;
 while Jana2Remote1.UDPBeschaeftigt do Application.ProcessMessages;
 LockState := Jana2Remote1.GetLockState;

// Jetzt die interne Auswertung
 Internetverbindungen.Text := inttostr(Inetconns);
 if ConnState < 255 then
   StatusText := StatusAuswahl[ConnState]
  else
   StatusText := text_InternalError;

if LockState < 255 then
  Sperrtext := LockAuswahl[LockState]
 else
  Sperrtext := text_InternalError;

// Ein Balloon-Fenster wird angezeigt
if DoBalloonInfo then
   if (Statustext <> Status.Text) or
      (SperrText <> DFUEGesperrt.Text) then
    CoolTrayIcon1.ShowBalloonHint('Jana2 - Statusnderung',
      'DF-Status:' + #13 + Statustext+#13#13+
      'Sperr-Status:' + #13 + Sperrtext,
                            bitInfo, 10);

// Die Infos werden im Form hinterlassen
Status.Text := StatusText;
DFUEGesperrt.Text := SperrText;
ZeitBisAuflegen.Text := TimeStrFromSec(TimeToDisconnect);
DFUEIP.text := DUNIP;
OnlineZeit.Text := TimeStrFromSec(OnlineTime);

// Dann wird das Icon in der TNA aktualisiert
IconNr := icon_InternalError;
case ConnState of
cs_Offline: begin
              IconNr := icon_Offline;
              if LockState = ls_Locked then // Nur aus Kompatibilittsgrnden
                IconNr := icon_OfflineLocked;
              end;
cs_Online:  begin
              IconNr := icon_Online;
              if DUNIP = OfflineIP then IconNr := icon_Dialing // Nur aus Kompatibilittsgrnden
               else
                if TimeToDisconnect >= HighestTimeToDisconnect-1 then IconNr := icon_OnlineData;
              end;
cs_Dailing: IconNr := icon_Dialing;
cs_Error:   IconNr := icon_ExternalError;
cs_locked:  IconNr := icon_OfflineLocked;
end;

ImageList1.GetIcon(IconNr,CoolTrayIcon1.Icon);
CoolTrayIcon1.Refresh;

// Unten in der Form wird jetzt die Statuszeile neu aufgefllt
StatusBar1.SimpleText := DateTimeToStr(Now)+ ' Proxy-Anfrage abgeschlossen';

// und die TNA noch mit einem neuen Hint gefttert
CoolTrayicon1.Hint :=
   'Status: '+Status.Text+' ('+DFUEGesperrt.Text+')'+ #13#10+
   'Zeit bis Auflegen: '+ZeitBisAuflegen.Text+ #13#10+
   'IP: '+DFUEIP.text+ #13#10+
   'Onlinezeit: '+OnlineZeit.Text;

// Ntig, um festzustellen, ob Datentransfer stattfand
If TimeToDisconnect > HighestTimeToDisconnect then
 HighestTimeToDisconnect := TimeToDisconnect;

  {
  Wie erkenne ich folgendes:
  icon_OnlineMail;
  icon_OnlineMailData;
    Vorschlge an UlfSchaper@gmx.de!
    Ach ja: TimeToDisconnect = -2 ist auch bei "Flatrate" oder wenn eine
            bestehende Verbindung genutzt wird.
  }

end;

procedure TJana2Remote2Config.LogOut1Click(Sender: TObject);
begin
Jana2Remote1.Logout;
end;

procedure TJana2Remote2Config.Mailsabholen1Click(Sender: TObject);
begin
Jana2Remote1.FetchMails;
end;

procedure TJana2Remote2Config.Df1Click(Sender: TObject);
begin
Jana2Remote1.SwitchLockState;
end;

procedure TJana2Remote2Config.Jana2beenden1Click(Sender: TObject);
begin
  if Application.Messagebox('Bestehende Verbindungen werden gekappt!','Beenden',mb_OKCancel)=IDOK then
    begin
      Jana2Remote1.ShutDownJana;
    end;
end;

procedure TJana2Remote2Config.Jana2Remote1Error(Sender: TObject;
  Text: String);
begin
 Timer1.Enabled := false;
 Aktiviert.Checked := false;
 StatusBar1.SimpleText := Text;
 ImageList1.GetIcon(icon_InternalError,CoolTrayIcon1.Icon);
 CoolTrayIcon1.Refresh;
end;

procedure TJana2Remote2Config.BitBtn5Click(Sender: TObject);
var Reg : TRegIniFile;
begin
  // Edit-Felder in Registry und Komponenten speichern
  Timer1.Enabled := false;
  Reg := TRegIniFile.Create('Software\Ulf Schaper');
  Reg.WriteInteger('Jana 2 Remote 2','Proxy Port',ProxyPort.Value);
  Jana2Remote1.Port := ProxyPort.Value;
  Reg.WriteString('Jana 2 Remote 2','Proxy Host',ProxyHost.Text);
  Jana2Remote1.Host := ProxyHost.Text;
  Reg.WriteInteger('Jana 2 Remote 2','Abfrageinterval',Abfrageinterval.Value);
  Timer1.Interval := Abfrageinterval.Value;
  Reg.WriteBool('Jana 2 Remote 2','Aktiviert',Aktiviert.Checked);
  Timer1.Enabled := Aktiviert.Checked;
  Reg.WriteBool('Jana 2 Remote 2','Ballooninfo',BalloonInfo.Checked);
  DoBalloonInfo := BalloonInfo.Checked;
  Reg.WriteString('Jana 2 Remote 2','HTTP User',HTTPBenutzername.Text);
  Reg.WriteString('Jana 2 Remote 2','HTTP Passwort',HTTPPasswort.Text);
  Reg.Free;
  // Fr den Fall, dass wegen Einstellungsfehlern keine Daten mehr
  // gefunden werden, wird ein Fehler angezeigt
  ImageList1.GetIcon(icon_InternalError,CoolTrayIcon1.Icon);
  CoolTrayIcon1.Refresh;
end;

procedure TJana2Remote2Config.IPindieZwischenablagekopieren1Click(
  Sender: TObject);
begin
Clipboard.AsText := (DFUEIP.Text);
end;

procedure TJana2Remote2Config.Jana2Einstellungen1Click(Sender: TObject);
var url:string;
begin
url := 'http://'+Jana2Remote1.Host+':'+inttostr(Jana2Remote1.GetConfigPort)+'/jana-admin/';
ShellExecute(handle,'open',Pchar(URL),'','',SW_MAXIMIZE);
end;

procedure TJana2Remote2Config.Jana2neustarten1Click(Sender: TObject);
begin
  if Application.Messagebox('Bestehende Verbindungen werden gekappt!','Beenden',mb_OKCancel)=IDOK then
    begin
      Jana2Remote1.RestartJana(httpBenutzername.Text,httpPasswort.Text);
    end;
end;

end.
